CFPRIME COEFSC                                                          COEFSC      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE COEFSC(NTBL,ANGLE1,VMAG,COEF,CORTBL,CFLAG)             COEFSC      3
C                                                                       COEFSC      4
C  FINDING CORRECTIVE COEFFICIENT FOR PHASE SHIFTER                     COEFSC      5
C                                                                       COEFSC      6
      DIMENSION CORTBL(220)                                             COEFSC      7
      LOGICAL CFLAG                                                     COEFSC      8
C                                                                       COEFSC      9
      ANGM=0.0                                                          COEFSC     10
      IOFS=(NTBL-1)*22                                                  COEFSC     11
      COEF=CORTBL(IOFS+2)                                               COEFSC     12
      ANGMAX=CORTBL(IOFS+1)                                             COEFSC     13
      DO 80 I=4,22,2                                                    COEFSC     14
      IF(CORTBL(IOFS+I).EQ.0.0) GOTO 85                                 COEFSC     15
      ANGM=CORTBL(IOFS+I-1)                                             COEFSC     16
  80  CONTINUE                                                          COEFSC     17
  85  CONTINUE                                                          COEFSC     18
      IF(ANGMAX.LT.0.5.OR.ANGM.GT.1.5)THEN                              COEFSC     19
         ANGLE=ANGLE1                                                   COEFSC     20
      ELSE                                                              COEFSC     21
         ANGLE=VMAG                                                     COEFSC     22
      ENDIF                                                             COEFSC     23
      CFLAG=.TRUE.                                                      COEFSC     24
      IF (ANGLE.LT.CORTBL(IOFS+1)) RETURN                               COEFSC     25
C                                                                       COEFSC     26
      DO 90 I=3,21,2                                                    COEFSC     27
       IF( CORTBL(IOFS+I).GT.ANGMAX)THEN                                COEFSC     28
        ANGMAX=CORTBL(IOFS+I)                                           COEFSC     29
        COEF=CORTBL(IOFS+I+1)                                           COEFSC     30
       ENDIF                                                            COEFSC     31
  90  CONTINUE                                                          COEFSC     32
      IF(ANGLE.GT.ANGMAX) RETURN                                        COEFSC     33
C                                                                       COEFSC     34
      IV=1                                                              COEFSC     35
      IC=IOFS+2                                                         COEFSC     36
  100 IV=IV+1                                                           COEFSC     37
      IC=IC+2                                                           COEFSC     38
      ANGV=CORTBL(IC-1)                                                 COEFSC     39
      IF(ANGV.LT.ANGLE) GOTO 100                                        COEFSC     40
      ANG1=CORTBL(IC-3)                                                 COEFSC     41
      COF1=CORTBL(IC-2)                                                 COEFSC     42
      ANG2=ANGV                                                         COEFSC     43
      COF2=CORTBL(IC)                                                   COEFSC     44
      COEF=COF1+(COF2-COF1)*(ANGLE-ANG1)/(ANG2-ANG1)                    COEFSC     45
      CFLAG=.FALSE.                                                     COEFSC     46
      RETURN                                                            COEFSC     47
C                                                                       COEFSC     48
      END                                                               COEFSC     49
                                                                        COEFSC     50
